Page MenuHomeFreeBSD

Add on bhyverun a new option '-B' that gives the capability to change the smbios table type1 using an ucl based configuration file.
AbandonedPublic

Authored by araujo on May 18 2018, 6:53 AM.

Details

Summary

The smbios table type1 contains overall system information such like:
Manufacturer, Product Name, Version, Serial Number, SKU Number, Family and etc.

Would be interesting to let users be able to modify these attributes to allow them to emulate some specific system vendors.
As an example of usage at iXsystems, we are using it to simulate our enterprise product and be able to execute QA tests using bhyve.

Example of bios.conf file:

manufacturer="MY COMPANY"
version="5.0"
product = "MY PRODUCT" 
serial="1234567890"
family="MY FAMILY"

Example bhyve parameter:

bhyve -B /z/bios.conf
Test Plan

Before patch using (dmidecode -t 1):

Handle 0x0001, DMI type 1, 27 bytes
System Information
        Manufacturer:
        Product Name: BHYVE
        Version: 1.0
        Serial Number: None
        UUID: 9E6A5CEF-AF60-393C-9E8F-72287178CAA5
        Wake-up Type: Power Switch
        SKU Number: None
        Family:

After patch using (dmidecode -t 1):

Handle 0x0001, DMI type 1, 27 bytes
System Information
        Manufacturer: MY COMPANY
        Product Name: MY PRODUCT
        Version: 5.0
        Serial Number: 1234567890
        UUID: 2B3A65C9-44C0-B035-8871-E33F5D3BD23E
        Wake-up Type: Power Switch
        SKU Number: None
        Family: MY FAMILY

Diff Detail

Repository
rS FreeBSD src repository
Lint
Lint OK
Unit
No Unit Test Coverage
Build Status
Buildable 16696
Build 16590: arc lint + arc unit

Event Timeline

araujo created this revision.May 18 2018, 6:53 AM
araujo edited the test plan for this revision. (Show Details)May 18 2018, 6:54 AM
araujo removed a reviewer: rgrimes.
araujo edited the summary of this revision. (Show Details)May 18 2018, 6:55 AM
araujo edited reviewers, added: grehan, tychon, anish, jhb; removed: rgrimes.
imp added inline comments.May 18 2018, 4:10 PM
usr.sbin/bhyve/smbiostbl.c
347 ↗(On Diff #42688)

why this change?

araujo updated this revision to Diff 42733.May 19 2018, 9:30 AM

ops gratuitous change slipped in, I fixed that. Thank you @imp!

araujo marked an inline comment as done.May 19 2018, 9:32 AM
araujo added inline comments.
usr.sbin/bhyve/smbiostbl.c
347 ↗(On Diff #42688)

I have fixed that, thank you!

bcr accepted this revision.May 19 2018, 2:59 PM
bcr added a subscriber: bcr.

OK from manpages. Thanks for working on it!

This revision is now accepted and ready to land.May 19 2018, 2:59 PM
0mp added a subscriber: 0mp.Oct 26 2018, 12:44 PM
0mp added inline comments.
usr.sbin/bhyve/bhyve.8
35

I guess that this revision is going to change significantly based on what you told me in the comment on D2448 but it might be relevant to future changes ;)

The -B option is missing from the synopsis section.

araujo abandoned this revision.Feb 22 2019, 5:06 AM
araujo marked an inline comment as done.